library(nnet)
rawData = read.table("ozone-wind.txt")
x = rawData[[1]]
y = rawData[[2]]
x.mu = mean(x)
x.sd = sd(x)
y.mu = mean(y)
y.sd = sd(y)

tx = seq(min(x),max(x),length=200)

nu = c(0,0.0001,0.001,0.01,0.05,0.1,0.5,1,1.5,2,4)
load(file="ozone-cv-mlp-10-error.robj")

bestE = min(errors)

postscript(file="mlp-ozone-cv.eps",onefile=F,paper="special",width=11.69,height=8.27)
par(mai=c(0.8,0.8,0.4,0.1),mfrow=c(3,4),oma=c(0.1,0.1,1.5,0.1))
j = 1
for(decay in nu) {
  load(file=paste("mlp-ozone-cv.10.",decay,".robj",sep=""))
  ty = y.sd*predict(mlp,as.matrix((tx-x.mu)/x.sd))+y.mu
  plot(x,y,xlab="Wind",ylab="Ozone",main=decay)
  lines(tx,ty,col="red")
  if(errors[j] == bestE) {
    bestMLP = mlp
  }
  j = j+1
}
title("Weight decay (10 neurones)",outer=T,cex=2)
dev.off()
postscript(file="mlp-ozone-cv-best.eps",onefile=F,paper="special",width=11.69,height=8.27)
par(mai=c(0.8,0.8,0.4,0.1))
ty = y.sd*predict(bestMLP,as.matrix((tx-x.mu)/x.sd))+y.mu
plot(x,y,xlab="Wind",ylab="Ozone")
lines(tx,ty,col="red")
dev.off()
