library(nnet)
rawData = read.table("ozone-wind.txt")
x = rawData[[1]]
y = rawData[[2]]
x.mu = mean(x)
x.sd = sd(x)
y.mu = mean(y)
y.sd = sd(y)

tx = seq(min(x),max(x),length=200)
nu = c(0,0.0001,0.001,0.01,0.05,0.1,0.2,0.4,0.6,0.8,1,1.5)

postscript(file="mlp-ozone-noise.eps",onefile=F,paper="special",width=11.69,height=8.27)
par(mai=c(0.8,0.8,0.4,0.1),mfrow=c(3,4),oma=c(0.1,0.1,1.5,0.1))
for(decay in nu) {
  load(file=paste("mlp-ozone-noise.10.",decay,".robj",sep=""))
  ty = y.sd*predict(mlp,as.matrix((tx-x.mu)/x.sd))+y.mu
  plot(x,y,xlab="Wind",ylab="Ozone",main=decay)
  lines(tx,ty,col="red")
}
title("Injection de bruit (10 neurones)",outer=T,cex=2)
dev.off()
