source("utilitaires.R")
rawData = read.table("ozone-wind.txt")
x = rawData[[1]]
y = rawData[[2]]
x.mu = mean(x)
x.sd = sd(x)
y.mu = mean(y)
y.sd = sd(y)
x = (x-x.mu)/x.sd
y = (y-y.mu)/y.sd
tx = seq(min(x),max(x),length=200)

load(file="mlp-ozone-cv.10.0.robj")

mlp.OBD = mlp
mlp.OBS = mlp.OBD
mlp.error = mlp

#plot(x,y)
#lines(tx,predict(mlp.OBD,as.matrix(tx)),col="red")
#pause=readline()

wts.OBD = mlp$wts
wts.OBS = mlp$wts
wts.error = mlp$wts

mask.OBD = rep(TRUE,length(wts.OBD))
mask.OBS = rep(TRUE,length(wts.OBS))
mask.error = rep(TRUE,length(wts.OBS))

postscript(file="mlp-ozone-obd.eps",onefile=F,paper="special",width=11.69,height=8.27)
par(mai=c(0.8,0.8,0.4,0.1),mfrow=c(3,4),oma=c(0.1,0.1,1.5,0.1))
for(i in 1:12) {
  s.OBD =  saliency.OBD(mlp.OBD,x,y)
  nb = find.first(order(s.OBD),mask.OBD)
  print(paste("OBD",i,nb))
  wts.OBD[nb] = 0
  mask.OBD[nb] = F
  mlp.OBD = nnet(as.matrix(x),as.matrix(y),size=10,linout=T,maxit=1000,trace=F,reltol=1e-9,Wts=wts.OBD,mask=mask.OBD)
  wts.OBD = mlp.OBD$wts
  plot(x,y,xlab="Wind",ylab="Ozone",main=i)
  lines(tx,predict(mlp.OBD,as.matrix(tx)),col="red")
#  pause=readline()
}
title("Suppression de poids par OBD",outer=T,cex=2)
dev.off()

postscript(file="mlp-ozone-obs.eps",onefile=F,paper="special",width=11.69,height=8.27)
par(mai=c(0.8,0.8,0.4,0.1),mfrow=c(3,4),oma=c(0.1,0.1,1.5,0.1))
for(i in 1:12) {
  s.OBS =  saliency.OBS(mlp.OBS,x,y)
  nb = find.first(order(s.OBS),mask.OBS)
  wts.OBS[nb] = 0
  mask.OBS[nb] = F
  print(paste("OBS",i,nb))
  mlp.OBS = nnet(as.matrix(x),as.matrix(y),size=10,linout=T,maxit=1000,trace=F,reltol=1e-9,Wts=wts.OBS,mask=mask.OBS)
  wts.OBS = mlp.OBS$wts
  plot(x,y,xlab="Wind",ylab="Ozone",main=i)
  lines(tx,predict(mlp.OBS,as.matrix(tx)),col="red")
#  pause=readline()
}
title("Suppression de poids par OBS",outer=T,cex=2)
dev.off()

postscript(file="mlp-ozone-error.eps",onefile=F,paper="special",width=11.69,height=8.27)
par(mai=c(0.8,0.8,0.4,0.1),mfrow=c(3,4),oma=c(0.1,0.1,1.5,0.1))
for(i in 1:12) {
  s.error =  saliency.error(mlp.error,x,y)
  nb = find.first(order(s.error),mask.error)
  wts.error[nb] = 0
  mask.error[nb] = F
  print(paste("error",i,nb))
  mlp.error = nnet(as.matrix(x),as.matrix(y),size=10,linout=T,maxit=1000,trace=F,reltol=1e-9,Wts=wts.error,mask=mask.error)
  wts.error = mlp.error$wts
  plot(x,y,xlab="Wind",ylab="Ozone",main=i)
  lines(tx,predict(mlp.error,as.matrix(tx)),col="red")
#  pause=readline()
}
title("Suppression de poids par E",outer=T,cex=2)
dev.off()
