source("utilitaires.R")
rawData = read.table("ozone-wind.txt")
x = rawData[[1]]
y = rawData[[2]]
x.mu = mean(x)
x.sd = sd(x)
y.mu = mean(y)
y.sd = sd(y)
x = (x-x.mu)/x.sd
y = (y-y.mu)/y.sd

x = as.matrix(x)
y = as.matrix(y)

nu = c(0,0.0001,0.001,0.01,0.05,0.1,0.5,1,1.5,2,4)

errors = rep(0,length(nu))
j = 1
for(decay in nu) {
  print(decay)
  errors[j] = cross.valid(build.mlp,decay,x,y,10,10)
  print(errors[j])
  mlp = build.mlp(x,y,10,decay)
  save(mlp,file=paste("mlp-ozone-cv.10.",decay,".robj",sep=""))
  j = j+1
}
save(errors,file="ozone-cv-mlp-10-error.robj")
