source("utilitaires.R")
rawData = read.table("ozone-wind.txt")
noiseData = read.table("noise.txt")
x = rawData[[1]]
y = rawData[[2]]
dx = noiseData[[1]]
x.mu = mean(x)
x.sd = sd(x)
y.mu = mean(y)
y.sd = sd(y)
x = (x-x.mu)/x.sd
y = (y-y.mu)/y.sd

nu = c(0,0.0001,0.001,0.01,0.05,0.1,0.2,0.4,0.6,0.8,1,1.5,2)

for(decay in nu) {
  print(decay)
  mlp = build.mlp(rep(x,10)+decay*dx,rep(y,10),10,0)
  save(mlp,file=paste("mlp-ozone-noise.10.",decay,".robj",sep=""))
}
