# utilitaires
source("inversion.R")
library(nnet)
repeatMlp=function(X,Y,siz,nb,H=F) {
  bestMlp=nnet(X,Y,size=siz,linout=T,maxit=1000,trace=F,reltol=1e-9,Hess=H);
  for(i in 2:nb) {
    mlp=nnet(X,Y,size=siz,linout=T,maxit=1000,trace=F,reltol=1e-9,Hess=H)
    if(mlp$value<bestMlp$value) {
      bestMlp=mlp
    }
  }
  bestMlp;
}

slicer=function(ind,slices,nb) {
  size=as.integer(length(ind)/slices);
  if(nb<slices) {
    ind[((nb-1)*size+1):(nb*size)];
  } else {
    ind[((nb-1)*size+1):length(ind)];
  }
}

cross.valid=function(model.builder,nu,u,v,nb,size) {
  indices=seq(1,nrow(u))
  val=0
  for(i in 1:nb) {
    testInd=slicer(indices,nb,i)
#    print(testInd)
    model=model.builder(as.matrix(u[-testInd,]),as.matrix(v[-testInd,]),size,nu)
    temp=mean((predict(model,as.matrix(u[testInd,]))-as.matrix(v[testInd,]))^2)
#    print(temp)
    val=val+temp
  }
  val/nb
}

build.mlp=function(X,Y,siz,nu,H=F) {
  bestMlp=nnet(X,Y,size=siz,linout=T,maxit=1000,trace=F,reltol=1e-9,decay=nu,Hess=H)
  for(i in 2:10) {
    mlp=nnet(X,Y,size=siz,linout=T,maxit=1000,trace=F,reltol=1e-9,decay=nu,Hess=H)
    if(mlp$value<bestMlp$value) {
      bestMlp=mlp
    }
  }
  bestMlp;
}

saliency.OBD=function(mlp,X,Y) {
  H = nnet.Hess(mlp,X,Y)
  diag(H) * (mlp$wts^2) 
}

saliency.OBS=function(mlp,X,Y) {
  H = nnet.Hess(mlp,X,Y)
  invH = inv.svd(H,tol=1e-16)
  (mlp$wts^2) / diag(invH) 
}

find.first=function(X,mask) {
  for(i in 1:length(X)) {
    if(mask[X[i]]) {
      break;
    }
  }
  X[i]
}

saliency.error=function(mlp,X,Y) {
  wSave = mlp$wts
  result = rep(0,length(wSave))
  for(i in 1:length(wSave)) {
    mlp$wts = wSave
    mlp$wts[i] = 0
    result[i] = mean((predict(mlp,as.matrix(X))-as.matrix(Y))^2)
  }
  mlp$wts = wSave
  result
}

build.mlp.classif=function(X,Y,siz,nu,H=F) {
  bestMlp=nnet(X,Y,size=siz,softmax=T,maxit=1000,trace=F,reltol=1e-9,decay=nu,Hess=H)
  for(i in 2:10) {
    mlp=nnet(X,Y,size=siz,softmax=T,maxit=1000,trace=F,reltol=1e-9,decay=nu,Hess=H)
    if(mlp$value<bestMlp$value) {
      bestMlp=mlp
    }
  }
  bestMlp;
}
